SPI\_saveplan

|        SPI\_saveplan        |                        |                         |                  |                                       |
|:---------------------------:|------------------------|-------------------------|------------------|---------------------------------------|
|[Prev](spi-spi-keepplan.html)|[Up](spi-interface.html)|47.1. Interface Functions|[Home](index.html)| [Next](spi-spi-register-relation.html)|

---

[]()

## SPI\_saveplan

SPI\_saveplan — save a prepared statement

## Synopsis

```
SPIPlanPtr SPI_saveplan(SPIPlanPtr plan)

```

## Description

`SPI_saveplan` copies a passed statement (prepared by `SPI_prepare`) into memory that will not be freed by `SPI_finish` nor by the transaction manager, and returns a pointer to the copied statement. This gives you the ability to reuse prepared statements in the subsequent invocations of your C function in the current session.

## Arguments

`SPIPlanPtr *`plan`*`

 the prepared statement to be saved

## Return Value

 Pointer to the copied statement; or `NULL` if unsuccessful. On error, `SPI_result` is set thus:

`SPI_ERROR_ARGUMENT`

 if *`plan`* is `NULL` or invalid

`SPI_ERROR_UNCONNECTED`

 if called from an unconnected C function

## Notes

 The originally passed-in statement is not freed, so you might wish to do `SPI_freeplan` on it to avoid leaking memory until `SPI_finish`.

 In most cases, `SPI_keepplan` is preferred to this function, since it accomplishes largely the same result without needing to physically copy the prepared statement's data structures.

---

|[Prev](spi-spi-keepplan.html)|[Up](spi-interface.html)| [Next](spi-spi-register-relation.html)|
|:----------------------------|:----------------------:|--------------------------------------:|
|        SPI\_keepplan        |   [Home](index.html)   |        SPI\_register\_relation        |

 // \<![CDATA[ \<-- For SVG support if ('WebSocket' in window) { (function() { function refreshCSS() { var sheets = [].slice.call(document.getElementsByTagName("link")); var head = document.getElementsByTagName("head")[0]; for (var i = 0; i \< sheets.length; ++i) { var elem = sheets[i]; head.removeChild(elem); var rel = elem.rel; if (elem.href && typeof rel != "string" || rel.length == 0 || rel.toLowerCase() == "stylesheet") { var url = elem.href.replace(/(&|\\?)\_cacheOverride=\\d+/, ''); elem.href = url + (url.indexOf('?') \>= 0 ? '&' : '?') + '\_cacheOverride=' + (new Date().valueOf()); } head.appendChild(elem); } } var protocol = window.location.protocol === 'http:' ? 'ws://' : 'wss://'; var address = protocol + window.location.host + window.location.pathname + '/ws'; var socket = new WebSocket(address); socket.onmessage = function(msg) { if (msg.data == 'reload') window.location.reload(); else if (msg.data == 'refreshcss') refreshCSS(); }; console.log('Live reload enabled.'); })(); } // ]]\>